Index: src/docparser.cpp
===================================================================
--- src/docparser.cpp	(revision 637)
+++ src/docparser.cpp	(working copy)
@@ -42,6 +42,8 @@
 #include "language.h"
 #include "portable.h"
 
+#include "outputlist.h"
+
 // debug off
 #define DBG(x) do {} while(0)
 
@@ -3758,6 +3760,40 @@
 
 //--------------------------------------------------------------------------
 
+QCString DocTitle::internalName() const {
+	QListIterator<DocNode> l_iter(m_children);
+	DocNode *l_node;
+	QCString l_retval("");
+    //warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: internal name begin");
+	for(l_iter.toFirst();(l_node=l_iter.current());++l_iter){
+        //warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: Node Type %d", l_node->kind());
+		switch(l_node->kind()) {
+		case Kind_Word:
+		{
+    		//warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: found word");
+			DocWord *l_word = (DocWord*)l_node;
+			l_retval.append(l_word->word());
+			break;
+		}
+		case Kind_WhiteSpace:
+		{
+    		//warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: found whitespace");
+			DocWhiteSpace *l_whitespace = (DocWhiteSpace*)l_node;
+			l_retval.append(l_whitespace->chars());
+			break;
+		}
+		// TODO: Handle other valid nodes of a DocTitle
+		// 			see: defaultHandleToken()
+		default: 
+    		//warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: found default");
+			break;
+	    }
+	}
+	l_retval = l_retval.stripWhiteSpace();
+    //warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: internal name result '%s'", l_retval.data());
+	return l_retval;
+}
+
 void DocTitle::parse()
 {
   DBG(("DocTitle::parse() start\n"));
@@ -3820,17 +3856,17 @@
   v->visitPost(this);
 }
 
-int DocSimpleSect::parse(bool userTitle)
+int DocSimpleSect::parse()
 {
   DBG(("DocSimpleSect::parse() start\n"));
   g_nodeStack.push(this);
 
   // handle case for user defined title
-  if (userTitle)
-  {
-    m_title = new DocTitle(this);
-    m_title->parse();
-  }
+  //if (userTitle)
+  //{
+  //  m_title = new DocTitle(this);
+  //  m_title->parse();
+  //}
   
   // add new paragraph as child
   DocPara *par = new DocPara(this);
@@ -3955,6 +3991,7 @@
     case Attention:  return "attention";
     case User:       return "user";
     case Rcs:        return "rcs";
+    case Progression: return "progression";
   }
   return "unknown";
 }
@@ -4121,20 +4158,163 @@
 
 //--------------------------------------------------------------------------
 
+QCString getSimpleSectTypeString(DocSimpleSect::Type t) 
+{
+  switch (t)
+  {
+	case DocSimpleSect::Unknown:    break;
+    case DocSimpleSect::See:        return "see";
+    case DocSimpleSect::Return:     return "return";
+    case DocSimpleSect::Author:     // fall through
+    case DocSimpleSect::Authors:    return "author";
+    case DocSimpleSect::Version:    return "version";
+    case DocSimpleSect::Since:      return "since";
+    case DocSimpleSect::Date:       return "date";
+    case DocSimpleSect::Note:       return "note";
+    case DocSimpleSect::Warning:    return "warning";
+    case DocSimpleSect::Pre:        return "pre";
+    case DocSimpleSect::Post:       return "post";
+    case DocSimpleSect::Invar:      return "invariant";
+    case DocSimpleSect::Remark:     return "remark";
+    case DocSimpleSect::Attention:  return "attention";
+    case DocSimpleSect::User:       return "user";
+    case DocSimpleSect::Rcs:        return "rcs";
+    case DocSimpleSect::Progression: return "progression";
+  }
+  return "unknown";
+}
+
+bool shouldGroup(DocSimpleSect::Type t, DocTitle *title) {
+  if( t == DocSimpleSect::Progression ) return TRUE;
+
+  QStrList l_list = Config_getList("GROUPED_SECTIONS");
+  QCString l_type = getSimpleSectTypeString(t);
+    
+  //warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: checking for grouping");
+  //warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: type string is: %s", l_type.data());
+
+  if( t == DocSimpleSect::User  ) {
+	  if( title == NULL ) return FALSE;
+	  l_type = title->internalName();
+  	  //warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: got internal name: %s", l_type.data());
+  }
+
+  for( char *l_str = l_list.first() ; l_str != NULL ; l_str = l_list.next() ) {
+	QCString l_elem(l_str);
+	if( t==DocSimpleSect::User ) {
+  	  //warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: checking rule: %s", l_elem.data());
+  	  //warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: checking rule for paragraph: %s", l_elem.left(4).data());
+      if( !l_elem.stripPrefix("par:") ) continue;
+  	  //warn_doc_error(g_fileName,doctokenizerYYlineno,"Debug: checking paragraph title: %s", l_elem.data());
+	}
+	if( l_elem == l_type ) return TRUE;
+  }
+  return FALSE;
+}
+
+
 int DocPara::handleSimpleSection(DocSimpleSect::Type t, bool xmlContext)
 {
   DocSimpleSect *ss=0;
-  if (!m_children.isEmpty() &&                           // previous element
+
+  DocTitle *l_title = NULL;
+  if( t == DocSimpleSect::User ) {
+	  g_nodeStack.push(this);
+	  l_title = new DocTitle(NULL);
+	  l_title->parse();
+	  DocNode *n=g_nodeStack.pop();
+	  ASSERT(n==this);
+  }
+
+  if( shouldGroup(t, l_title) ) {
+	  DocNode *l_node;
+	  DocSimpleSect *l_targetNode = NULL;
+
+	  // If there is a Doc Root To search from then start there
+	  if( parent() != NULL && parent()->kind() == Kind_Root &&
+		  !((DocRoot*)parent())->children().isEmpty() ) 
+	  {
+	    DocRoot *l_root = (DocRoot*)parent();
+      QListIterator<DocNode> l_iter(l_root->children());
+	    for( l_iter.toFirst();(l_node=l_iter.current());++l_iter) {
+		    if( l_node->kind() == Kind_Para )
+		    {
+          DocPara *l_para = (DocPara*)l_node;
+          QListIterator<DocNode> l_paraIter(l_para->children());
+          DocNode *l_child = NULL;
+          for( l_paraIter.toFirst();(l_child=l_paraIter.current());++l_paraIter) 
+          {
+            if( l_child->kind() == Kind_SimpleSect ) 
+            {
+              DocSimpleSect *l_sect = (DocSimpleSect*)l_child;
+              if( l_sect->type() != t ) continue;
+              if( t != DocSimpleSect::User ) {
+                l_targetNode = l_sect;
+                break;
+              }
+              else if( l_title != NULL )
+              { 
+                QCString l_myTitle(l_title->internalName());
+                QCString l_otherTitle(l_sect->title()->internalName());
+                if( l_myTitle == l_otherTitle ) 
+                {
+                  l_targetNode = l_sect;
+                  break;
+                }
+              }
+            }
+          }
+        }
+      }
+    }
+    // If we haven't already found a node to group with search our own children
+    if( l_targetNode == NULL )	
+    {
+      // Search All Nodes In the this node for an existing
+      //  simple section to group with
+      QListIterator<DocNode> l_iter(m_children);
+      for( l_iter.toFirst();(l_node=l_iter.current());++l_iter) {
+        if( l_node->kind() == Kind_SimpleSect ) {
+          DocSimpleSect *l_sect = (DocSimpleSect*)l_node;
+          if( l_sect->type() != t ) continue;
+          if( t != DocSimpleSect::User ) {
+            l_targetNode = l_sect;
+            break;
+          }
+          else {
+            QCString l_myTitle(l_title->internalName());
+            QCString l_otherTitle(l_title->internalName());
+            if( l_myTitle == l_otherTitle ) {
+              l_targetNode = l_sect;
+              break;
+            }
+          }
+        }
+      }
+    }
+    if( l_targetNode != NULL ) {
+      ss = l_targetNode;
+      delete l_title;
+    }
+  }
+  if (ss == NULL &&
+      !m_children.isEmpty() &&                           // previous element
       m_children.last()->kind()==Kind_SimpleSect &&      // was a simple sect
       ((DocSimpleSect *)m_children.last())->type()==t && // of same type
       t!=DocSimpleSect::User)                            // but not user defined
   {
     // append to previous section
     ss=(DocSimpleSect *)m_children.last();
+    delete l_title;
   }
-  else // start new section
+  else 
+  if( ss == NULL )// start new section
   {
     ss=new DocSimpleSect(this,t);
+    if( l_title != NULL ) {
+      l_title->setParent(ss);
+      ss->setTitle(l_title);
+    }
     m_children.append(ss);
   }
   int rv = RetVal_OK;
@@ -4144,8 +4324,9 @@
   }
   else
   {
-    rv = ss->parse(t==DocSimpleSect::User);
+    rv = ss->parse();
   }
+  
   return (rv!=TK_NEWPARA) ? rv : RetVal_OK;
 }
 
@@ -4586,6 +4767,9 @@
     case CMD_ATTENTION:
       retval = handleSimpleSection(DocSimpleSect::Attention);
       break;
+    case CMD_PROGRESSION:
+      retval = handleSimpleSection(DocSimpleSect::Progression);
+      break;
     case CMD_PAR:
       retval = handleSimpleSection(DocSimpleSect::User);
       break;
@@ -5968,18 +6152,17 @@
   doctokenizerYYsetStatePara();
   int retval=0;
 
-  // first parse any number of paragraphs
-  bool isFirst=TRUE;
-  DocPara *lastPar=0;
+  if( m_lastPar ) m_lastPar->markLast(FALSE);
+
   do
   {
     DocPara *par = new DocPara(this);
-    if (isFirst) { par->markFirst(); isFirst=FALSE; }
+    if (m_children.isEmpty()) { par->markFirst(); }
     retval=par->parse();
     if (!par->isEmpty()) 
     {
       m_children.append(par);
-      lastPar=par;
+      m_lastPar=par;
     }
     else
     {
@@ -6002,7 +6185,7 @@
       warn_doc_error(g_fileName,doctokenizerYYlineno,"Warning: found paragraph command outside of subsubsection context!");
     }
   } while (retval!=0 && retval!=RetVal_Section && retval!=RetVal_Internal);
-  if (lastPar) lastPar->markLast();
+  if (m_lastPar) m_lastPar->markLast();
 
   // then parse any number of level1 sections
   while (retval==RetVal_Section)
@@ -6038,9 +6221,9 @@
 
 //--------------------------------------------------------------------------
 
-DocNode *validatingParseDoc(const char *fileName,int startLine,
+DocNode *validatingParseDoc(QList<ParseRequest> requests,
                             Definition *ctx,MemberDef *md,
-                            const char *input,bool indexWords,
+                            bool indexWords,
                             bool isExample, const char *exampleName,
                             bool singleLine, bool linkFromIndex)
 {
@@ -6155,38 +6338,51 @@
     g_searchUrl="";
   }
 
-  g_fileName = fileName;
-  g_relPath = (!linkFromIndex && ctx) ? 
+  DocRoot *root = new DocRoot(md!=0,singleLine);
+
+  QListIterator<ParseRequest> l_requests(requests);
+  ParseRequest *l_request;
+  for( l_requests.toFirst();(l_request=l_requests.current());++l_requests)
+  {
+    g_fileName = l_request->fileName;
+  	g_relPath = (!linkFromIndex && ctx) ? 
                QString(relativePathToRoot(ctx->getOutputFileBase())) : 
                QString("");
-  //printf("ctx->name=%s relPath=%s\n",ctx->name().data(),g_relPath.data());
-  g_memberDef = md;
-  g_nodeStack.clear();
-  g_styleStack.clear();
-  g_initialStyleStack.clear();
-  g_inSeeBlock = FALSE;
-  g_insideHtmlLink = FALSE;
-  g_includeFileText = "";
-  g_includeFileOffset = 0;
-  g_includeFileLength = 0;
-  g_isExample = isExample;
-  g_exampleName = exampleName;
-  g_hasParamCommand = FALSE;
-  g_hasReturnCommand = FALSE;
-  g_paramsFound.setAutoDelete(FALSE);
-  g_paramsFound.clear();
-  g_sectionDict = 0; //sections;
+  	//printf("ctx->name=%s relPath=%s\n",ctx->name().data(),g_relPath.data());
+  	g_memberDef = md;
+  	g_nodeStack.clear();
+  	g_styleStack.clear();
+  	g_initialStyleStack.clear();
+  	g_inSeeBlock = FALSE;
+  	g_insideHtmlLink = FALSE;
+  	g_includeFileText = "";
+  	g_includeFileOffset = 0;
+  	g_includeFileLength = 0;
+  	g_isExample = isExample;
+  	g_exampleName = exampleName;
+  	g_hasParamCommand = FALSE;
+  	g_hasReturnCommand = FALSE;
+  	g_paramsFound.setAutoDelete(FALSE);
+  	g_paramsFound.clear();
+  	g_sectionDict = 0; //sections;
   
-  //printf("Starting comment block at %s:%d\n",g_fileName.data(),startLine);
-  doctokenizerYYlineno=startLine;
-  doctokenizerYYinit(input,g_fileName);
+  	//printf("Starting comment block at %s:%d\n",g_fileName.data(),startLine);
+  	doctokenizerYYlineno=l_request->startLine;
 
+    QCString l_input(l_request->docString);
+    if( l_input.at(l_input.length()-1) != '\n' ) {
+      l_input += '\n';
+    }
+    doctokenizerYYinit(l_input.data(),g_fileName.data());
 
-  // build abstract syntax tree
-  DocRoot *root = new DocRoot(md!=0,singleLine);
-  root->parse();
+  	// build abstract syntax tree
+  	root->parse();
+    
+    checkUndocumentedParams();
+    detectNoDocumentedParams();
+  }
 
-
+  //if( true )
   if (Debug::isFlagSet(Debug::PrintTree))
   {
     // pretty print the result
@@ -6196,8 +6392,6 @@
   }
 
 
-  checkUndocumentedParams();
-  detectNoDocumentedParams();
 
   // TODO: These should be called at the end of the program.
   //doctokenizerYYcleanup();
Index: src/classdef.cpp
===================================================================
--- src/classdef.cpp	(revision 637)
+++ src/classdef.cpp	(working copy)
@@ -866,7 +866,10 @@
     // repeat brief description
     if (!briefDescription().isEmpty() && Config_getBool("REPEAT_BRIEF"))
     {
-      ol.parseDoc(briefFile(),briefLine(),this,0,briefDescription(),FALSE,FALSE);
+      QList<ParseRequest> l_requests;
+      ParseRequest l_brief = {briefFile(), briefDescription(), briefLine()};
+      l_requests.append(&l_brief);
+      ol.parseDoc(l_requests,this,0,FALSE,FALSE);
     }
     if (!briefDescription().isEmpty() && Config_getBool("REPEAT_BRIEF") &&
         !documentation().isEmpty())
@@ -883,8 +886,11 @@
     // write documentation
     if (!documentation().isEmpty())
     {
+      QList<ParseRequest> l_requests;
+      ParseRequest l_docs = {docFile(), documentation(), docLine()};
+      l_requests.append(&l_docs);
       //ol.newParagraph();
-      ol.parseDoc(docFile(),docLine(),this,0,documentation(),TRUE,FALSE);
+      ol.parseDoc(l_requests,this,0,TRUE,FALSE);
     }
     // write type constraints
     writeTypeConstraints(ol,this,m_impl->typeConstraints);
@@ -1254,7 +1260,11 @@
   {
     if (!Config_getBool("DETAILS_AT_TOP")) 
     {
-      ol.parseDoc(briefFile(),briefLine(),this,0,briefDescription(),TRUE,FALSE);
+      QList<ParseRequest> l_requests;
+      ParseRequest l_brief = {briefFile(), briefDescription(), briefLine()};
+      l_requests.append(&l_brief);
+
+      ol.parseDoc(l_requests,this,0,TRUE,FALSE);
       ol.pushGeneratorState();
       ol.disable(OutputGenerator::RTF);
       ol.writeString(" \n");
Index: src/htmldocvisitor.cpp
===================================================================
--- src/htmldocvisitor.cpp	(revision 637)
+++ src/htmldocvisitor.cpp	(working copy)
@@ -514,6 +514,8 @@
       m_t << theTranslator->trRemarks(); break;
     case DocSimpleSect::Attention:
       m_t << theTranslator->trAttention(); break;
+    case DocSimpleSect::Progression:
+      m_t << theTranslator->trProgression(); break;
     case DocSimpleSect::User: break;
     case DocSimpleSect::Rcs: break;
     case DocSimpleSect::Unknown:  break;
Index: src/translator_br.h
===================================================================
--- src/translator_br.h	(revision 637)
+++ src/translator_br.h	(working copy)
@@ -32,7 +32,7 @@
 #ifndef TRANSLATOR_BR_H
 #define TRANSLATOR_BR_H
 
-class TranslatorBrazilian : public Translator
+class TranslatorBrazilian : public TranslatorAdapter_1_5_6
 {
   public:
 
Index: src/memberdef.cpp
===================================================================
--- src/memberdef.cpp	(revision 637)
+++ src/memberdef.cpp	(working copy)
@@ -1453,7 +1453,11 @@
      )
   {
     ol.startMemberDescription();
-    ol.parseDoc(briefFile(),briefLine(),getOuterScope()?getOuterScope():d,this,briefDescription(),TRUE,FALSE);
+    QList<ParseRequest> l_requests;
+    ParseRequest l_brief = {briefFile(), briefDescription(), briefLine()};
+    l_requests.append(&l_brief);
+
+    ol.parseDoc(l_requests,getOuterScope()?getOuterScope():d,this,TRUE,FALSE);
     if (detailsVisible) 
     {
       ol.pushGeneratorState();
@@ -1938,27 +1942,43 @@
       ) 
      )  
   { 
-    ol.parseDoc(briefFile(),briefLine(),getOuterScope()?getOuterScope():container,this,brief,FALSE,FALSE);
+    QList<ParseRequest> l_requests;
+    ParseRequest l_brief = {briefFile(),brief,briefLine()};
+    l_requests.append(&l_brief);
+
+    ol.parseDoc(l_requests,getOuterScope()?getOuterScope():container,this,FALSE,FALSE);
     ol.newParagraph();
   }
 
   /* write detailed description */
   if (!detailed.isEmpty() || !m_impl->inbodyDocs.isEmpty())
   { 
-    ol.parseDoc(docFile(),docLine(),getOuterScope()?getOuterScope():container,this,detailed+"\n",TRUE,FALSE);
+    QList<ParseRequest> l_requests;
+    ParseRequest l_doc = {docFile(),detailed+"\n",docLine()};
+    ParseRequest l_inbody;
+	
+    l_requests.append(&l_doc);
     if (!m_impl->inbodyDocs.isEmpty())
     {
-      ol.newParagraph();
-      ol.parseDoc(inbodyFile(),inbodyLine(),getOuterScope()?getOuterScope():container,this,m_impl->inbodyDocs+"\n",TRUE,FALSE);
+      l_inbody.fileName = inbodyFile();
+      l_inbody.startLine = inbodyLine();
+      l_inbody.docString = m_impl->inbodyDocs+"\n";
+      l_requests.append(&l_inbody);
     }
+	
+    ol.parseDoc(l_requests,getOuterScope()?getOuterScope():container,this,TRUE,FALSE);
   }
   else if (!brief.isEmpty() && (Config_getBool("REPEAT_BRIEF") ||
         !Config_getBool("BRIEF_MEMBER_DESC")))
   {
     if (!m_impl->inbodyDocs.isEmpty())
     {
+      QList<ParseRequest> l_requests;
+      ParseRequest l_inbody = {inbodyFile(),m_impl->inbodyDocs+"\n",inbodyLine()};
+      l_requests.append(&l_inbody);
+
       ol.newParagraph();
-      ol.parseDoc(inbodyFile(),inbodyLine(),getOuterScope()?getOuterScope():container,this,m_impl->inbodyDocs+"\n",TRUE,FALSE);
+      ol.parseDoc(l_requests,getOuterScope()?getOuterScope():container,this,TRUE,FALSE);
     }
   }
 
@@ -1982,10 +2002,14 @@
         ol.docify(a->name);
         ol.endDescTableTitle();
         ol.startDescTableData();
-        ol.parseDoc(docFile(),docLine(),
+		
+        QList<ParseRequest> l_requests;
+        ParseRequest l_doc = {docFile(),a->docs+"\n",docLine()};
+        l_requests.append(&l_doc);
+
+        ol.parseDoc(l_requests,
                     getOuterScope()?getOuterScope():container,
                     this,         // memberDef
-                    a->docs+"\n", // docStr
                     TRUE,         // indexWords
                     FALSE         // isExample
                    );
@@ -2051,7 +2075,11 @@
 
           if (!fmd->briefDescription().isEmpty())
           { 
-            ol.parseDoc(fmd->briefFile(),fmd->briefLine(),getOuterScope()?getOuterScope():container,fmd,fmd->briefDescription(),TRUE,FALSE);
+            QList<ParseRequest> l_requests;
+            ParseRequest l_brief = {fmd->briefFile(),fmd->briefDescription(),fmd->briefLine()};
+            l_requests.append(&l_brief);
+
+            ol.parseDoc(l_requests,getOuterScope()?getOuterScope():container,fmd,TRUE,FALSE);
             //ol.newParagraph();
           }
           if (!fmd->briefDescription().isEmpty() && 
@@ -2061,7 +2089,11 @@
           }
           if (!fmd->documentation().isEmpty())
           { 
-            ol.parseDoc(fmd->docFile(),fmd->docLine(),getOuterScope()?getOuterScope():container,fmd,fmd->documentation()+"\n",TRUE,FALSE);
+            QList<ParseRequest> l_requests;
+            ParseRequest l_doc = {fmd->docFile(),fmd->documentation()+"\n",fmd->docLine()};
+            l_requests.append(&l_doc);
+
+            ol.parseDoc(l_requests,getOuterScope()?getOuterScope():container,fmd,TRUE,FALSE);
           }
           ol.endDescTableData();
         }
